## org.opencyc.cycobject
Class CycSymbol

    java.lang.Object
      |
      +--org.opencyc.cycobject.CycObject
            |
            +--org.opencyc.cycobject.CycSymbol

All Implemented Interfaces:
  java.lang.Comparable, java.io.Serializable

public class CycSymbol
extends CycObject
implements java.lang.Comparable, java.io.Serializable

Provides the behavior and attributes of an OpenCyc symbol, typically used to represent api function names, and non `CycConstant` parameters.

Author:
  Stephen L. Reed

  Copyright 2001 Cycorp, Inc., license is open source GNU LGPL.

  the license

  www.opencyc.org

  OpenCyc at SourceForge

  THIS SOFTWARE AND KNOWLEDGE BASE CONTENT ARE PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE OPENCYC ORGANIZATION OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE AND KNOWLEDGE BASE CONTENT, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See Also:
  Serialized Form

Field Summary
`static java.lang.String` `cycSymbolXMLTag` The name of the XML tag for this object.
`java.lang.String` `symbolName` The symbol represented as a `String`.

Constructor Summary
`CycSymbol(java.lang.String symbolName)` Constructs a new `CycSymbol` object.

Method Summary
`int` `compareTo(java.lang.Object object)` Compares this object with the specified object for order.
`boolean` `equals(java.lang.Object object)` Returns `true` iff some object equals this `CycSymbol`
`boolean` `isKeyword()` Returns `true` iff this symbol is a SubL keyword.
`static boolean` `isValidSymbolName(java.lang.String string)` Returns `true` iff the given string is a valid symbol name.
`java.lang.String` `toString()` Returns the string representation of the `CycSymbol`
`void` `toXML(XMLWriter xmlWriter, int indent, boolean relative)` Prints the XML representation of the CycSymbol to an `XMLWriter`
`java.lang.String` `toXMLString()` Returns the XML representation of this object.

Methods inherited from class org.opencyc.cycobject.CycObject
`cyclify`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### cycSymbolXMLTag

    public static final java.lang.String cycSymbolXMLTag

  The name of the XML tag for this object.

### symbolName

    public java.lang.String symbolName

  The symbol represented as a `String`.

Constructor Detail

### CycSymbol

    public CycSymbol(java.lang.String symbolName)

  Constructs a new `CycSymbol` object.
  Parameters:
    `symbolName` - the `String` name of the `CycSymbol`.

Method Detail

### toString

    public java.lang.String toString()

  Returns the string representation of the `CycSymbol`
  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    the representation of the `CycSymbol` as a `String`

### equals

    public boolean equals(java.lang.Object object)

  Returns `true` iff some object equals this `CycSymbol`
  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `object` - the `Object` for equality comparison
  Returns:
    equals `boolean` value indicating equality or non-equality.

### isKeyword

    public boolean isKeyword()

  Returns `true` iff this symbol is a SubL keyword.
  Returns:
    `true` iff this symbol is a SubL keyword

### compareTo

    public int compareTo(java.lang.Object object)

  Compares this object with the specified object for order. Returns a negative integer, zero, or a positive integer as this object is less than, equal to, or greater than the specified object.
  Specified by:
    `compareTo` in interface `java.lang.Comparable`
  Parameters:
    `object` - the reference object with which to compare.
  Returns:
    a negative integer, zero, or a positive integer as this object is less than, equal to, or greater than the specified object

### isValidSymbolName

    public static boolean isValidSymbolName(java.lang.String string)

  Returns `true` iff the given string is a valid symbol name.
  Parameters:
    `string` - the name to be tested
  Returns:
    `true` iff the given string is a valid symbol name

### toXMLString

    public java.lang.String toXMLString()
                                 throws java.io.IOException

  Returns the XML representation of this object.
  Returns:
    the XML representation of this object

### toXML

    public void toXML(XMLWriter xmlWriter,
                      int indent,
                      boolean relative)
               throws java.io.IOException

  Prints the XML representation of the CycSymbol to an `XMLWriter`
  Parameters:
    `xmlWriter` - an `XMLWriter`
    `indent` - an int that specifies by how many spaces to indent
    `relative` - a boolean; if true indentation is relative, otherwise absolute